import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class AI here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class AI extends Board
{
    public int AI;
    public Ring r;
    public boolean a;
    int initialX = 0;
    int initialY = 0;
    int bestX = 0;
    int bestY = 0;
    int priority = 0;
    int priority2 = -999;
    int five = 0;
    int four = 0;
    int three = 0;
    int eFive = 0;
    int eFour = 0;
    int eThree = 0;
    int loopCount = 0;
    public AI()
    {    
        super();
        AI = BLACK_;
        a = false;
        setPaintOrder(Ring.class);
    }
    public void act()
    {
        if(player_ == AI)
        {
            Greenfoot.delay(Greenfoot.getRandomNumber(20)+20);
            AIAction(AI);
            scanForWin();
        }
        if(Greenfoot.getMouseInfo() != null && Greenfoot.mouseClicked(this) && !(a))
        {
            x_ = Greenfoot.getMouseInfo().getX();
            y_ = Greenfoot.getMouseInfo().getY();
            if(player_ == BLACK_)
            {
                addBlack();
            }
            else
            {
                addWhite();
            }
            scanForWin();
        }
    }
    
    public void AIAction(int AI)
    {
        bigReset();
        while(x_ < 19)
        {
            smallReset();
            if(board_[x_][y_] == BLANK_)//only blank points can a stone be placed
            {
                scan1();//scan to see if board[x][y] is = win or enemy win(updates priority2 if either is true)
                scan2();//updates moves to make connect five,four,and three if(AI placed a stone here)
                scan3();//updates moves for enemy to make connect five,four,and three if(enemy places a stone here)
                determinePriority();//determine the priority of board[x][y] using the info that is acuired with scan2() && scan3()
                
                if(priority >= priority2 && priority > -24)
                {
                    priority2 = priority;
                    bestX = x_;
                    bestY = y_;
                }
                else if(priority > priority2)
                {
                    bestX = Greenfoot.getRandomNumber(6)+6;
                    bestY = Greenfoot.getRandomNumber(6)+6;
                    while(board_[bestX][bestY] != BLANK_)
                    {
                        if(loopCount > 10)
                        {
                            bestX = Greenfoot.getRandomNumber(18);
                            bestY = Greenfoot.getRandomNumber(18);
                        }
                        loopCount ++;
                    }
                }
            }
            if(x_ == 18 && y_ < 18)//resets the loop so it runs again till all points covered
            {
                x_ = -1;
                y_ ++;
            }
            x_++;
        }
        x_ = bestX;//updates the position because scanAll() uses x_ & y_ to scan
        y_ = bestY;
        AIPlaceStone(bestX, bestY, a);//places stone
    }
    
    public void AIPlaceStone(int bestX, int bestY, boolean a)
    {
        board_[bestX][bestY] = AI;
        if(AI == WHITE_)
        {
            White w = new White();
            addObject(w, bestX, bestY);
        }
        else
        {
            Black b = new Black();
            addObject(b, bestX, bestY);
        }
        if(a)
        {
            AI = opP();
        }
        player_ = opP();// switch turns
    }
    public int opP()//gives the opposite player
    {
        if(player_ == BLACK_)
        {
            return WHITE_;
        }
        else
        {
            return BLACK_;
        }
    }
    public void setAI(int a)
    {
        AI = a;
    }
    public void AIVSAI()
    {
        a = true;
    }
    public void scan1()//scans for immediat win/lose prevention stone placements
    {
        if(scanAll(5, opP()))
        {
            bestX = x_;
            bestY = y_;
            priority2 = 2;
        }
        else if(scanAll(5, AI))
        {
            bestX = x_;
            bestY = y_;
            priority2 = 1;
        }
    }
    public void scan2()//updates moves to make connect five,four,and three if(AI placed a stone here)
    {
        x_ = initialX;
        y_ = initialY;
        board_[x_][y_] = AI;//temp change
        x_ = 0;
        y_ = 0;
        while(x_ < 19)
        {
            if(board_[x_][y_] == BLANK_)
            {
                if(scanAll(5, opP()))
                {
                    five ++;
                }
                else if(scanAll(4, opP()))
                {
                    four ++;
                }
                else if(scanAll(3, opP()))
                {
                    three ++;
                }
            }
            if(x_ == 18 && y_ < 18)//resets the loop so it runs again till all points covered
            {
                x_ = -1;
                y_ ++;
            }
            x_ ++;
        }
        x_ = initialX;
        y_ = initialY;
        board_[x_][y_] = BLANK_;//change back to blank
    }
    public void scan3()//updates moves for enemy to make connect five,four,and three if(enemy places a stone here)
    {
        x_ = initialX;
        y_ = initialY;
        board_[x_][y_] = opP();//temp change
        x_ = 0;
        y_ = 0;
        while(x_ < 19)
        {
            if(board_[x_][y_] == BLANK_)
            {
                if(scanAll(5, AI))
                {
                    eFive ++;
                }
                else if(scanAll(4, AI))
                {
                    eFour ++;
                }
                else if(scanAll(3, AI))
                {
                    eThree ++;
                }
            }
            if(x_ == 18 && y_ < 18)//resets the loop so it runs again till all points covered
            {
                x_ = -1;
                y_ ++;
            }
            x_ ++;
        }
        x_ = initialX;
        y_ = initialY;
        board_[x_][y_] = BLANK_;//change back to blank
    }
    public void determinePriority()//determine the priority of board[x][y] using the info that is acuired with scan2() && scan3()
    {
        if(five >= 2)
        {
            priority = 0;
        }
        else if(eFive >= 2)
        {
            priority = -1;
        }
        else if(five == 1 && four >= 2)
        {
            priority = -2;
        }
        else if(eFour >= 3)
        {
            priority = -3;
        }
        else if(four >= 2 && eFour == 1)
        {
            priority = -4;
        }
        else if(four >= 2 && three >= 2)
        {
            priority = -5;
        }
        else if(four >= 2 && eThree == 1)
        {
            priority = -6;
        }
        else if(four >= 2)
        {
            priority = -7;
        }
        else if(five == 1 && eFour == 1)
        {
            priority = -8;
        }
        else if(five == 1 && eThree == 1)
        {
            priority = -9;
        }
        else if(five == 1)
        {
            priority = -10;
        }
        else if(eFive == 1 && eFour >= 2)
        {
            priority = -11;
        }
        else if(eFour >= 2 && three == 1)
        {
            priority = -12;
        }
        else if(eFour >= 2 && eThree >= 2)
        {
            priority = -13;
        }
        else if(eFour >= 2)
        {
            priority = -14;
        }
        else if(eFive == 1 && three == 1)
        {
            priority = -15;
        }
        else if(eFive == 1)
        {
            priority = -16;
        }
        else if(four == 1 && three >= 2)
        {
            priority = -17;
        }
        else if(eThree >= 3)
        {
            priority = -18;
        }
        else if(three >= 2 && eThree == 1)
        {
            priority = -19;
        }
        else if(three >= 2)
        {
            priority = -20;
        }
        else if(four == 1 && eThree == 1)
        {
            priority = -21;
        }
        else if(four == 1)
        {
            priority = -22;
        }
        else if(eFour == 1 && eThree >= 2)
        {
            priority = -23;
        }
        else if(eThree >= 2)
        {
            priority = -24;
        }
        else if(eFour == 1)
        {
            priority = -25;
        }
        else if(three == 1)
        {
            priority = -26;
        }
        else if(eThree == 1)
        {
            priority = -27;
        }
        else
        {
            priority = -28;
        }
    }
    public void bigReset()//reset everything the AI() methud needs to scan
    {
        x_ = 0;//resets both x_ and y_ to 0 so start scanning from 0,0
        y_ = 0;
        initialX = 0;
        initialY = 0;
        bestX = 0;
        bestY = 0;
        priority = 0;
        priority2 = -50;
        five = 0;
        four = 0;
        three = 0;
        eFive = 0;
        eFour = 0;
        eThree = 0;
    }
    public void smallReset()//reset everything except for priority2(because it's needed to keep track of highest priority) x_ and y_
    {
        five = 0;
        four = 0;
        three = 0;
        eFive = 0;
        eFour = 0;
        eThree = 0;
        initialX = x_;
        initialY = y_;
        priority = 0;
        loopCount = 0;
    }
}
